//Mr. Ripper Plugin API v0.17
#ifndef RIP_API_H
#define RIP_API_H

#if defined(_MSC_VER)
 #pragma once
#endif

#if defined(__BORLANDC__)
  #pragma option -a2
#elif defined(_MSC_VER)
 #pragma pack(push,1)
#else
 #pragma pack(1)
#endif

//  (    )
enum{
        RIP_INFO_TYPE_GRAPH, //  BMP, JPG, GIF ...
        RIP_INFO_TYPE_VIDEO, //  AVI, SMK, MPG...
        RIP_INFO_TYPE_SOUND, //  WAV, MP3, MOD, XM, MIDI...
        RIP_INFO_TYPE_PACK,  // (        )
        RIP_INFO_TYPE_OTHER, // ( ,      ) RTF, RIFF...
        // API v0.13
        RIP_INFO_TYPE_MUSIC, //,  , 
        RIP_INFO_TYPE_TEXT,  //  PDF, RTF  ...
        RIP_INFO_TYPE_EXE    // 
};

// ,     

//    (, ,  ,  )
//  ,     . 
//   - -1
typedef long (WINAPI *RIPFIND) (PUCHAR, PUCHAR, long, long);

//    ( ,   , ,  )
//  ,     ,   . 
//   - -1
typedef long (WINAPI *RIPFINDINFILE)(const char*, long, PUCHAR, long);

//    ( ,   , ,  )
//    
//  ,   -1
typedef long (WINAPI *RIPREADFROMFILE)(const char*, long, void *, long);

//    ( ,   , ,  )
//    
//  ,   -1
typedef long (WINAPI *RIPSAVETOFILE)(const char*, long, void *, long);

//    ( , ,  )
//    
//  ,   -1
typedef long (WINAPI *RIPAPPENDTOFILE)(const char*, void *, long);

//v.0.16
//      
//(  ,   ,    ,
//  ,   )
//    = -1,       
//    
//  ,   -1
typedef long (WINAPI *RIPFILETOFILECOPY)(const char*, const char*, long, long, long);

//v.0.17
// 2     Intel  Motorolla  
typedef short (WINAPI *RIPSWAPWORD)(short);

//v.0.17
// 4     Intel  Motorolla  
typedef long (WINAPI *RIPSWAPLONG)(long);

//v.0.17
//     
typedef char* (WINAPI *RIPEXTRACTPATH)(const char *);

//v.0.17
//    
typedef char* (WINAPI *RIPEXTRACTNAME)(const char *);

//v.0.17
//    
typedef BOOL (WINAPI *RIPFILEINDIR)(const char *, const char *);

//v.0.17
// ,    Extract*
typedef void (WINAPI *RIPFREEMEM)(void *);

//v.0.17
//  
//( ,   ,  ,     , 
// ,  )
typedef int (WINAPI *RIPSHOWMESSAGE)(BOOL, BOOL, BOOL, BOOL, const char * const *, int, int);

//        
// API v0.13
struct RIP_NFO_FMT {
    long    StructSize;
    int     Type;                       //  RIP_INFO_TYPE_...
    char  * RegPath;                    //       (     API  )
    char  * OptionString;               //,       Mr.Ripper'
};

//      
struct RIP_NFO {                        
        // API v0.16
        long    StructSize;
        // API v0.13
        RIP_NFO_FMT * KnownFormats;        
        short         nKnownFormats;
        char        * Copyright;        //   
        long          Reserved1;
        long          Reserved2;
};

//    
struct RIP_FORM_INFO {
        long    StructSize;
        char    Extension[10];    //   "." (: ".bmp")
        char    Description[300]; // 
        // API v0.14
        void *  UserData;
        long    UserDataLen;
        // API v0.16
        long    Reserved1;
};

//      
struct RIP_FILE_INFO {                          
        long    StructSize;
        char *  FullFileName; //   
        char *  Description;  //         
        long    StartOffset;  //     
        long    FileSize;     //  
        // API v0.16
        long    UnpSize;     //  
        // API v0.14
        void *  UserData;
        long    UserDataLen;
        // API v0.16
        long    Reserved1;
};

// ,  
struct RIP_SERVICE_FUNC {
        long                StructSize;
        RIPFIND             Find;
        RIPFINDINFILE       FindInFile;
        RIPREADFROMFILE     ReadFromFile;
        RIPSAVETOFILE       SaveToFile;
        RIPAPPENDTOFILE     AppendToFile;
        // API v0.16
        RIPFILETOFILECOPY   FileToFileCopy;
		// API v0.17
        RIPSWAPWORD			SwapWord;
		RIPSWAPLONG			SwapLong;
		RIPEXTRACTNAME		ExtractName;
		RIPEXTRACTPATH		ExtractPath;
		RIPFILEINDIR		FileInDir;
		RIPFREEMEM			FreeMem;
		RIPSHOWMESSAGE		ShowMessage;
};

// 
#ifdef __cplusplus
extern "C"{
#endif

// ,     RIP_INFO_TYPE_PACK
//      
//( , ,  ,      ,   ,   
//    ,  :   ,   ,  )
//    ,   ,  -1   
long WINAPI FormatCheck(short Fmt, const char * FileName, PUCHAR BaseString, long readed, long *HeadOffset, long *SomeOffset, long *FileSize, long *FileOffset, long *UnpSize, struct RIP_FORM_INFO *finfo, long WorkFileSize, struct RIP_SERVICE_FUNC *func);

// ,    RIP_INFO_TYPE_PACK
//        
//( , ,  ,      ,   ,   
//    ,     ,   ,   ,  )
//    ,   ,  -1   
long WINAPI PackCheck(short Fmt, const char * FileName, PUCHAR BaseString, long readed, long *HeadOffset, long *SomeOffset, long *FileSize, long *FileOffset, struct RIP_FILE_INFO **finfo, long *FilesNumber, long WorkFileSize, struct RIP_SERVICE_FUNC *func);

// ,    RIP_INFO_TYPE_PACK
//    
//(    ,   )
// TRUE   , FALSE -  
BOOL WINAPI PackCheckFree(struct RIP_FILE_INFO *finfo, long FilesNumber);

//  ,      ,    ,    , /
//  ,  - .        .
//(  ,   ,   ,    ,   ,
// ,  )
// TRUE   ,  FALSE   
//  Silent==TRUE       
BOOL WINAPI GetFile(short Fmt, const char * PackName, const char * FileName, const char * PathName, long StartOffset, long FileSize, long UnpSize, BOOL Silent, struct RIP_SERVICE_FUNC *func);

// API v0.14
//  ,      ,    ,    , /
//  ,  - .        .
//          .
//(  ,   ,   ,    ,   ,
// ,  ,  )
// TRUE   ,  FALSE   
//  Silent==TRUE       
BOOL WINAPI GetFileUD(short Fmt, const char * PackName, const char * FileName, const char * PathName, long StartOffset, long FileSize, long UnpSize, BOOL Silent, struct RIP_SERVICE_FUNC *func, void * UserData);

// 
//    
// TRUE    , FALSE   
BOOL WINAPI PluginInfo (struct RIP_NFO *RipNfo);


// API v 0.13
// 
//   ,    PluginInfo
// TRUE    , FALSE   
BOOL WINAPI PluginInfoFree (struct RIP_NFO *RipNfo);

// API v 0.16
//,    RIP_INFO_TYPE_PACK 
// ,      
//  
//   
//FAT -   ,      
// FAT        
//FAT -   ,        
//  long
// TRUE    , FALSE   
BOOL WINAPI GetFAT (short Fmt, const char * PackName, long Offset, long Size, void ** FAT, struct RIP_SERVICE_FUNC * func);

// API v 0.16
//,    RIP_INFO_TYPE_PACK 
// ,       
//
//   
//PackName -   
//FileName -   
//PathName -     
//FAT -   ,   GetFAT
//StartOffset -       
//FileSize -        (  )
//Compress -   
// TRUE    , FALSE   
BOOL WINAPI PutFile(short Fmt, 
                    const char * PackName, 
                    const char * FileName, 
                    const char * PathName, 
                    const char * DiskPathName, 
                    long * StartOffset, 
                    long * FileSize, 
                    long * UnpSize, 
                    long Offset, long Size, 
                    void ** FAT, BOOL Compress, struct RIP_SERVICE_FUNC * func);

// API v 0.16
//,    RIP_INFO_TYPE_PACK 
// ,       
//
//   
//PackName -   
//FileName -   
//FAT -   ,   GetFAT
// TRUE    , FALSE   
BOOL WINAPI DelFile(short Fmt, 
                    const char * PackName, 
                    const char * FileName,                     
                    long StartOffset, 
                    long FileSize, 
                    long UnpSize, 
                    void ** FAT, struct RIP_SERVICE_FUNC * func);

// API v 0.16
//,    RIP_INFO_TYPE_PACK  
// GetFAT
// ,  FAT'   
//FAT -   ,   GetFAT
// TRUE    , FALSE   
BOOL WINAPI FreeFAT (short Fmt, const char * PackName, const char * TmpName, long Offset, long Size, long WorkFileSize, void ** FAT, struct RIP_SERVICE_FUNC * func);

#ifdef __cplusplus
};
#endif

#if defined(__BORLANDC__)
  #pragma option -a
#elif defined(_MSC_VER)
  #pragma pack(pop)
#else
  #pragma pack()
#endif

#endif //RIP_API_H