//Mr. Ripper Plugin API v0.17
unit rip_api;
interface

const MAX_PATH            = 260;
//  (    )
const RIP_INFO_TYPE_GRAPH = 0; //  BMP, JPG, GIF ...
const RIP_INFO_TYPE_VIDEO = 1; //  AVI, SMK, MPG...
const RIP_INFO_TYPE_SOUND = 2; // , ...
const RIP_INFO_TYPE_PACK  = 3; // (        )
const RIP_INFO_TYPE_OTHER = 4; // ( ,      )...
// API v0.13
const RIP_INFO_TYPE_MUSIC = 5; //,  , 
const RIP_INFO_TYPE_TEXT  = 6; //  PDF, RTF  ...
const RIP_INFO_TYPE_EXE   = 7; // 

// ,     
type 
//    (, ,  ,  )
//  ,     . 
//   - -1
 TRipFind         = function(SearchString, BaseString: PChar; SSSize, BSsize: longint): longint;stdcall;

//    ( ,   , ,  )
//  ,     ,   . 
//   - -1
 TRipFindInFile   = function(const FileName: PChar; StartOffset: longint; SearchString: PChar; SSsize: longint): longint;stdcall;

//    ( ,   , ,  )
//    
//  ,   -1
 TRipReadFromFile = function(const FileName: PChar; StartOffset: longint; var Buffer; BufferSize: longint): longint;stdcall;

//    ( ,   , ,  )
//    
//  ,   -1
 TRipSaveToFile   = function(const FileName: PChar; StartOffset: longint; var Buffer; BufferSize: longint): longint;stdcall;

//    ( , ,  )
//    
//  ,   -1
 TRipAppendToFile = function(const FileName: PChar; var Buffer; BufferSize: longint): longint;stdcall;

//v.0.16
//      
//(  ,   ,    ,
//  ,   )
//    = -1,       
//    
//  ,   -1
// < MODDING BY Z!nCh >
// TRipFileToFileCopy = function(const SrcFileName: PChar; const DstFileName: PChar; SrcOffset, SrcSize, DstOffset: longint); 
TRipFileToFileCopy = function(const SrcFileName: PChar; const DstFileName: PChar; SrcOffset, SrcSize, DstOffset: longint): longint;stdcall;
// < MODDING BY Z!nCh >

//v.0.17
// 2     Intel  Motorolla  
 TRipSwapWord = function(Value: SmallInt): SmallInt;

//v.0.17
// 4     Intel  Motorolla  
 TRipSwapLong = function(Value: LongInt): LongInt;

//v.0.17
//     
 TRipExtractPath = function(const S: PCHAR): PCHAR;

//v.0.17
//    
 TRipExtractName = function(const S: PCHAR): PCHAR;

//v.0.17
//    
 TRipFileInDir = function(const Dir: PCHAR; const FileName: PCHAR): WORDBOOL;

//v.0.17
// ,    Extract*
 TRipFreeMem = procedure(var P);

//v.0.17
//  
//( ,   ,  ,     , 
// ,  )
 TRipShowMessage = function(Warning, KeepBG, LeftAlign, AllInOne: WORDBOOL; Items: PCHAR; ItemsNumber, ButtonsNumber: Integer): Integer;

//        
 PRipNfoFmt = ^TRipNfoFmt;
 TRipNfoFmt = packed record
  // API v0.16
  StructSize   : longint;
  // API v0.13
  MType        : integer;                 //  RIP_INFO_TYPE_...
  RegPath      : PChar;                   //       (     API  )       
  OptionString : PChar;                   //,       Mr.Ripper'
 end;

//      
 PRipNfo = ^TRipNfo;
 TRipNfo = packed record 
  // API v0.16
  StructSize   : longint;
  // API v0.13
  KnownFormats : PRipNfoFmt;        
  nKnownFormats: SmallInt;
  Copyright    : PChar;                   //   
  Reserved1    : LongInt; 
  Reserved2    : LongInt;
 end;

//   
 PRipFormInfo = ^TRipFormInfo;
 TRipFormInfo = packed record
  // API v0.16
  StructSize   : longint;
  // API v0.13
  Extension    : array[0..9]   of char;        //   "." (: ".bmp")
  Description  : array[0..299] of char;        // 
  // API v0.14
  UserData     : Pointer;                     //  
  UserDataLen  : LongInt;                      //    
  // API v0.16
  Reserved1    : LongInt; 
 end;

//   
 PRipFileInfo = ^TRipFileInfo;
 TRipFileInfo = packed record
  // API v0.16
  StructSize   : longint;
  // API v0.13
  FullFileName : PChar;                        //   
  Description  : PChar;                        // 
  StartOffset  : longint;                      //     
  FileSize     : longint;                      //  
  // API v0.16
  UnpSize      : longint;                      //  
  // API v0.14
  UserData     : Pointer;                      //  
  UserDataLen  : LongInt;                      //    
  // API v0.16
  Reserved1    : LongInt; 
 end;

// ,  
 PRipServiceFunc = ^TRipServiceFunc;
 TRipServiceFunc = packed record
  // API v0.16
  StructSize   : longint;
  // API v0.13
  Find        : TRipFind;
  FindInFile  : TRipFindInFile;
  ReadFromFile: TRipReadFromFile;
  SaveToFile  : TRipSaveToFile;
  AppendToFile: TRipAppendToFile;
  // API v0.16
// < MODDING BY Z!nCh >
//  FileToFileCopy: TFileToFileCopy;
  FileToFileCopy: TRipFileToFileCopy;
// < MODDING BY Z!nCh >
  
  // API v0.17
  SwapWord:     TRipSwapWord;
  SwapLong:     TRipSwapLong;
  ExtractPath:  TRipExtractPath;
  ExtractName:  TRipExtractName;
  FileInDir:    TRipFileInDir;
  FreeMem:      TRipFreeMem;
  ShowMessage:  TRipShowMessage;
 end;

{
// ,     RIP_INFO_TYPE_PACK
//      
//( ,  , ,  ,      , . ,   , 
//      ,  :   , 
//  ,  )
//    ,   ,  -1   
function FormatCheck(
                     Fmt            : SmallInt;
                     const FileName : PChar;
                     BaseString     : PChar;
                     readed         : longint;
                     var HeadOffset : Longint;
                     var SomeOffset : Longint;
                     var FileSize   : Longint;
                     var FileOffset : Longint;
                     var finfo      : TRipFormInfo;
                     WorkFileSize   : longint;
                     func           : PRipServiceFunc): longint;stdcall;export;

// ,    RIP_INFO_TYPE_PACK
//        
//( , ,  ,      , . ,   ,  
//    ,     ,   ,   ,  )
//    ,   ,  -1   
function PackCheck(
                   Fmt            : SmallInt;
                   const FileName : PChar;
                   BaseString     : PChar;
                   readed         : longint;
                   var HeadOffset : Longint;
                   var FileSize   : Longint;
                   var FileOffset : Longint;
                   var finfo      : PRipFileInfo;
                   var FilesNumber: longint;
                   WorkFileSize   : longint;
                   func           : PRipServiceFunc): longint;stdcall;export;

// ,    RIP_INFO_TYPE_PACK
//    
//(    ,   )
// TRUE   , FALSE -  
function PackCheckFree(var finfo      : PRipFileInfo;
                       FilesNumber: longint): BOOL;stdcall;export;

//  ,      ,    ,    ,
///   ,  - .        .
//( ,   ,   ,   ,    , 
// ,  ,  )
// TRUE   ,  FALSE   
//  Silent==TRUE       
function GetFile(
                 Fmt           : SmallInt;
                 const PackName: PChar;
                 const FileName: PChar;
                 const PathName: PChar;
                 StartOffset   : longint;
                 FileSize      : longint;
                 Silence       : WordBool;
                 func          : PRipServiceFunc): WordBool;stdcall;export;

//  ,      ,    ,    , /
//  ,  - .        .
//          .
//(  ,   ,   ,    ,   ,
// ,  ,  )
// TRUE   ,  FALSE   
//  Silent==TRUE       
function GetFileUD(
                   Fmt           : SmallInt;
                   const PackName: PChar;
                   const FileName: PChar;
                   const PathName: PChar;
                   StartOffset   : longint;
                   FileSize      : longint;
                   Silence       : WordBool;
                   func          : PRipServiceFunc;
                   UserData      : TPointer): WordBool;stdcall;export;

// 
//    
// TRUE    , FALSE   
function PluginInfo(var RipNfo: TRipNfo): WordBool; stdcall; export;

// 
//       PluginInfo
// TRUE    , FALSE   
function PluginInfoFree(var RipNfo: TRipNfo): WordBool; stdcall; export;

// API v 0.16
//,    RIP_INFO_TYPE_PACK 
// ,      
//  
//   
//FAT -   ,      
// FAT        
//FAT -   ,        
//  long
// TRUE    , FALSE   
function GetFAT (Fmt             : SmallInt;
                 const PackName  : PChar;
                 Offset,
                 Size            : LongInt;
                 var FAT         : Pointer;
                 func            : PRipServiceFunc): WorBool; stdcall; export;

// API v 0.16
//,    RIP_INFO_TYPE_PACK 
// ,       
//
//   
//PackName -   
//FileName -   
//PathName -     
//FAT -   ,   GetFAT
//StartOffset -       
//FileSize -        (  )
//Compress -   
// TRUE    , FALSE   
function PutFile(Fmt                     : SmallInt;
                 const PackName, 
                 const FileName, 
                 const PathName, 
                 const DiskPathName      : PChar;
                 var StartOffset, 
                 var FileSize, 
                 var UnpSize,
                 Offset, Size            : LongInt;
                 var FAT                 : Pointer;
                 Compress                : WordBool;
                 func                    : PRipServiceFunc): WorBool; stdcall; export;

// API v 0.16
//,    RIP_INFO_TYPE_PACK 
// ,       
//
//   
//PackName -   
//FileName -   
//FAT -   ,   GetFAT
// TRUE    , FALSE   
function DelFile(Fmt                     : SmallInt;
                 const PackName, 
                 const FileName          : PChar;
                 StartOffset, 
                 FileSize, 
                 UnpSize                 : LongInt;
                 var FAT                 : Pointer;
                 func                    : PRipServiceFunc): WorBool; stdcall; export;

// API v 0.16
//,    RIP_INFO_TYPE_PACK  
// GetFAT
// ,  FAT'   
//FAT -   ,   GetFAT
// TRUE    , FALSE   
function FreeFAT(Fmt                     : SmallInt;
                 const PackName, 
                 const TmpName           : PChar;
                 Offset, 
                 Size, 
                 WorkFileSize            : LongInt;
                 var FAT                 : Pointer;
                 func                    : PRipServiceFunc): WorBool; stdcall; export;
}

implementation
end.